/******************************************************************************
*
* Atmel Corporation
*
* ̧			: main.h
* ߲		: IAR EWAAVR 4.11A
* 			: $Revision: 1.0 $
* t			: $Date: 27.07, 2005$
* XV		: $Author: KMe$
*
* xҰ		: avr@atmel.com
*
* x޲	: ̗ATtiny45pɏĂ܂B
*
* pLq		: AVR441: ̧ݐ
*
* 			: ̧ݐ퉞p̂߂ͯ ̧
*
******************************************************************************/

// #include "iotiny45.h"	// IAR EWAVR 3.20łłَ̺߲ɂgpĂB
#include "ioavr.h"			// IAR EWAVR 4.11łłَ̺߲ɂgpĂB

/******************************************************************************
 * ֐^錾
 *****************************************************************************/

void main(void);
void init(void);
void calibrate(void);
void coilActivate(void);
void coilDeactivate(void);
void alarmActivate(void);
void alarmDeactivate(void);
void alarmToggle(void);
void handleTemperature(void);
signed char readTemperature(void);
void handleSpeedometer(void);
void handleTWI(void);
void EEPROM_write(unsigned int uiAddress, unsigned char ucData);
unsigned char EEPROM_read(unsigned int uiAddress);

#pragma vector = PCINT0_vect
__interrupt void pin_change(void);
#pragma vector = TIM0_OVF_vect
__interrupt void timer0_ovf(void);
#pragma vector = WDT_vect
__interrupt void wdt(void);

/******************************************************************************
 * EWAVR 4.10Błiotiny45.hł̈ȉޯĒ`͌Ă܂B̓4.1
 * 1AłŏCA]Ĉȉ̒`͕KvƂ܂B
 *****************************************************************************/

/* TIMSK */
/*
#define OCIE1A	6
#define OCIE1B	5
#define OCIE0A	4
#define OCIE0B	3
#define TOIE1	2
#define TOIE0	1
*/

/* GIMSK */
/*
#define INT0	6
#define PCIE	5
*/

/* WDTCR */
/*
#define WDTIF	7
#define WDTIE	6
#define WDP3	5
#define WDCE	4
#define WDE		3
#define WDP2	2
#define WDP1	1
#define WDP0	0
*/

/* TCCR0B */
/*
#define FOC0A	7
#define FOC0B	6
#define WGM02	3
#define CS02	2
#define CS01	1
#define CS00	0
*/

/******************************************************************************
 * EWAVR 4.10Błiotiny45.hł̈ȉޯĒ`͕sɐ錾Ă܂B
 * ̓4.11AłŏCA]Ĉȉ̒`͕KvƂ܂B
 *****************************************************************************/

/* EECR */
/*
#define EEMPE	2
#define EEPE	1
*/

/******************************************************************************
 * ̧ݓAxxAȂ
 *****************************************************************************/

#define HIGH_TEMP_ALARM_LIMIT	45			// xx(P)
#define LOW_RPM_ALARM_LIMIT		600			// x񉺌](RPMP,=10RPS)
#define LOW_RPS_ALARM_LIMIT		LOW_RPM_ALARM_LIMIT/60

#define CALIB_TEMP				25			// ͉x(P)

#define TWI_ADDRESS				0x00		// TWIڽEEPROMڽ(1޲)
#define TOS_ADDRESS				0x01		// x΍lEEPROMڽ(2޲)

// xx\(64޲)̐擪ڽBxx\͉xɑ΂RPSl蓖
// ĂQƕ\łB\̍ŏ̗vf10ɉb̉]ł̋߂ꂽ
// ̧ݑx^܂B̗vf16ɑ΂ĂŁA17A73܂ňȉ
// lłBʏA̧݂3000`6000RPMA50`100RPS܂B
// ̧݂~ɉ܂Œx]ł邩Ɋւ鉺܂B
#define TABLE_ADDRESS			0x10		// xxQƕ\擪EEPROMڽ(64޲)

// ΰيmAӰ فAŹAÓAxo͗pݐڑ`
#define IO_HALL					(1<<PB3)	// ΰيmڑޯĒl
#define IO_EXT					(1<<PB0)	// OoޯĒl

// b̉]ł̧RPS˽ؼlB̧ѳ͖ڕWRPŚ}HYST_RPSł͒߂
// ݂܂BȒl͋@BIȒx̂߂ɒԂɓņ݂U܂
// ɂ邩܂B
#define HYST_RPS				1

// ͎nɑ΂ĒJnɐ旧̉]\ɂ܂B
// ől255(Ȃchar)łB
#define START_REV				100

// PWMޭè قႷƁA̧݂~܂B̧݂̗͂ɉĉݒ肵Ă
// B\IɁA̧݉]8`10%ȉޭè قŕsȓɂȂ܂B
// PWM̉0.08~255=20ŔׂłB
#define PWM_LOW					20

#define CLK_PRESCALER			0			//  ۯOul(=OuȂ(8MHz))
#define TC_PRESCALER			(1 << CS02) | (1 << CS00)	// T/C0Oul(=1024Ou(7.8125kHz))
#define T0_CLK					7812		// /0̸ۯg(HzP)

#define T_OFFSET				270			// 艷x΍(x0ADCǂݎ)

#define MESSAGEBUF_SIZE			4			// TWIү ޯ̧e

#define TWI_CMD_MASTER_WRITE	0x10		// TWI呕uݖ
#define TWI_CMD_MASTER_READ		0x20		// TWI呕uǂݍݖ
