//***************************************************************************
//
//  ̧......: LCD_functions.c
//  ......: ATMEL Norway
//  ړIΏ..: ATmega169
//  ߲....: IAR EWAAVR 4.10B
//  ......: ۰,ްݒǉLCD֐
//  ......: 2.1
//
//  N   -   - 											- 
//  20021015 - 1.0 - 쐬											- LHM
//  20030116 - 2.0 - AVR Butterflyɺޕ␳						- KS
//  20050318 - 2.1 - ύX											- KMe
//
//***************************************************************************

#include <ioavr.h>

#include "main.h"
#include "Lcd_driver.h"
#include "Lcd_functions.h"
#include "BCD.h"

#define FALSE	0
#define TRUE	(!FALSE)

/* S̕ϐ` */

char CONTRAST = LCD_INITIAL_CONTRAST;		// LCDZWl
extern char gLCD_Start_Scroll_Timer;		// LCD۰يԊuvl (LCD_driver.cŎgp)

//*****************************************************************************
//*
//* ֐	: LCD_puts_f
//* 	: *pFlashStr : ׯ ؓ擪ʒu(߲)
//*			  scrollmode : (gp)
//* Ԃl	: Ȃ
//* ړI	: ׯ ؂Ɋi[ꂽLCDɐݒ
//*
//*****************************************************************************
void LCD_puts_f(char __flash *pFlashStr, char scrollmode)
{
  char i;													// Ɨp

  while (gLCD_Update_Required);								// LCD\XVvȂ܂őҋ@
  for (i = 0; pFlashStr[i] && i < TEXTBUFFER_SIZE; i++)		/* Iq܂ׯLCDޯ̧] */
  {
	gTextBuffer[i] = pFlashStr[i];
  }
  gTextBuffer[i] = '\0';									// LCDޯ̧ɏIqݒ
  if (i > 6)												// 6޲()zŁA
  {
	gScrollMode = 1;										// ۰ON׸ސݒ
	gScroll = 0;											// \Jnʒu
	gLCD_Start_Scroll_Timer = 3;							// ۰َvlN
  }
  else														// 6޲()ȓŁA
  {
	gScrollMode = 0;										// ۰OFF׸ސݒ
	gScroll = 0;											// \Jnʒu
  }
  gLCD_Update_Required = 1;									// LCD\XVv׸ސݒ
}

//*****************************************************************************
//*
//* ֐	: LCD_puts
//* 	: *pStr		 : 擪ʒu(߲)
//*			  scrollmode : (gp)
//* Ԃl	: Ȃ
//* ړI	: LCDɐݒ
//*
//*****************************************************************************
void LCD_puts(char *pStr, char scrollmode)
{
  char i;												// Ɨp

  while (gLCD_Update_Required);							// LCD\XVvȂ܂őҋ@
  for (i = 0; pStr[i] && i < TEXTBUFFER_SIZE; i++)		/* Iq܂ŕϐLCDޯ̧] */
  {
	gTextBuffer[i] = pStr[i];
  }
  gTextBuffer[i] = '\0';								// LCDޯ̧ɏIqݒ
  if (i > 6)											// 6޲()zŁA
  {
	gScrollMode = 1;									// ۰ON׸ސݒ
	gScroll = 0;										// \Jnʒu
	gLCD_Start_Scroll_Timer = 3;						// ۰َvlN
  }
  else													// 6޲()ȓŁA
  {
	gScrollMode = 0;									// ۰OFF׸ސݒ
	gScroll = 0;										// \Jnʒu
  }
  gLCD_Update_Required = 1;								// LCD\XVv׸ސݒ
}

//*****************************************************************************
//*
//* ֐	: LCD_putc
//* 	: digit		: LCDޯ̧̌ʒu(0)
//*			  character : 
//* Ԃl	: Ȃ
//* ړI	: LCDޯ̧Cӌʒuɕݒ
//*
//*****************************************************************************
void LCD_putc(char digit, char character)
{
  if (digit < TEXTBUFFER_SIZE)			// LCDޯ̧wŁA
	gTextBuffer[digit] = character;		// Ήޯ̧ʒuɎw蕶ݒ
}

//*****************************************************************************
//*
//* ֐	: LCD_Clear
//* 	: Ȃ
//* Ԃl	: Ȃ
//* ړI	: LCDޯ̧
//*
//*****************************************************************************
void LCD_Clear(void)
{
  char i;								// Ɨp

  for (i=0; i<TEXTBUFFER_SIZE; i++)		/* LCDޯ̧S󔒕ŏ */
	gTextBuffer[i] = ' ';
}

//*****************************************************************************
//*
//* ֐	: LCD_Colon
//* 	: show : (:)\ON/OFF ([TRUE|FALSE])
//* Ԃl	: Ȃ
//* ړI	: LCD̺(:)\ON/OFFݒ
//*
//*****************************************************************************
void LCD_Colon(char show)
{
  gColon = show;						// (:)\ON/OFF׸ސݒ
}

//*****************************************************************************
//*
//* ֐	: LCD_UpdateRequired
//* 	: update	 : LCD\XVvON/OFF ([TRUE|FALSE])
//*			  scrollmode : ۰ON/OFF ([TRUE|FALSE])
//* Ԃl	: Ȃ
//* ړI	: LCD\XVv׸ނƽ۰ ׸ނON/OFFݒ
//*
//*****************************************************************************
void LCD_UpdateRequired(char update, char scrollmode)
{

  while (gLCD_Update_Required);			// LCD\XVvȂ܂őҋ@
  gScrollMode = scrollmode;				// ۰ON/OFF׸ސݒ
  gScroll = 0;							// \Jnʒu
  gLCD_Update_Required = update;		// LCD\XVv׸ON/OFFݒ
}

//*****************************************************************************
//*
//* ֐	: LCD_FlashReset
//* 	: Ȃ
//* Ԃl	: Ȃ
//* ړI	: LCD_Ŏv
//*
//*****************************************************************************
void LCD_FlashReset(void)
{
  gFlashTimer = 0;						// _Ŏvl
}

//*****************************************************************************
//*
//* ֐	: SetContrast
//* 	: char input (ޮèԔԍ)
//* Ԃl	: char ST_state (S̏Ԕԍ)
//* ړI	: LCDZW
//*
//*****************************************************************************
char SetContrast(char input)
{
  static char enter = 1;						// ׸
  char CH, CL;									// Ɨp

  if (enter)									/* 񎞏 */
  {
	LCD_Clear();								// LCDޯ̧
	enter = 0;									// ׸މ
  }
  CH = CHAR2BCD2(CONTRAST);						// ZWl2lBCDlϊ
  CL = (CH & 0x0F) + '0';						// ZWl1̌擾
  CH = (CH >> 4) + '0';							// ZWl10̌擾
  LCD_putc(0, 'C');								// LCD1'C'ݒ
  LCD_putc(1, 'T');								// LCD2'T'ݒ
  LCD_putc(2, 'R');								// LCD3'R'ݒ
  LCD_putc(3, ' ');								// LCD4ɋ󔒕ݒ
  LCD_putc(4, CH);								// LCD5ɌZWl10̌ݒ
  LCD_putc(5, CL);								// LCD6ɌZWl1̌ݒ
  LCD_UpdateRequired(TRUE, 0);					// LCD\XVv׸ސݒ
  if (input == KEY_PLUS)						// ޮèONŁA
	CONTRAST++;									// ZWlis
  else if (input == KEY_MINUS)					// ޮèONŁA
	CONTRAST--;									// ZWl
  if (CONTRAST == 255)							// ZWl߂ŁA
	CONTRAST = 0;								// ZWlɕύX
  if (CONTRAST > 15)							// ZWl߂ŁA
	CONTRAST = 15;								// ZWlɕύX
  LCD_CONTRAST_LEVEL(CONTRAST);					// LCDZWXV/ݒ
  if (input == KEY_ENTER)						// ޮèONŁA
  {
	enter = 1;									// ׸ސݒ
	return ST_OPTIONS_DISPLAY_CONTRAST;			// "ZWύX"ƭԔԍƋɕA
  }
  return ST_OPTIONS_DISPLAY_CONTRAST_FUNC;		// ZWύXԔԍƋɕA
}
